/*
    Connectivity.cc
    Last edited 09/04/2003 6:46pm by Luca De Nardis
*/

//#include<stdio.h>
#include <omnetpp.h>
#include "fstream.h"
#include "./Libs/PacketDescriptor.h"
#include "./Libs/FPL.h"
#include "./Libs/Connection.h"
#include "./Libs/connList.h"

#define LE 1
#define LC 2
#define DATA 6
#define ACKDATA 23
#define NMAX 50
#define NUMCLASSES 3
#define deltasincro	0.2
#define GENERAMOBUPDATE 1
#define AGGIORNASTA 2
#define FINE 17
#define PACKETCHECK 18
#define PACKETSTATUS 22
#define PACKETSCHEDULE 19
#define REFRESHLIST 27
#define TERMINATE 28
#define REFRESHINGINTERVAL 5
#define STATINTERVAL 5
#define POWERMAPINTERVAL 15000
#define Resolution 0.5
#define Integration_time 5
#define STDPOWER 6.3E-11
#define LIGHTSPEED 3E8
#define MAXDATASIZE 1288


double PRESERVINGINTERVAL;

struct posizione	{double x;
			double y;
			} database[NMAX];

struct NeighbourRecord{
  double distance;
  bool distanceValidity;
  double time;
  double distanceEstimationTime;
  double lastPacketTime;
  int receivedPacketsMemory;
} NeighbourMatrix[NMAX][NMAX];


bool networkconnectivity[NMAX][NMAX];
double generatedMUI[NMAX][NMAX];
int pacchettiDATAinviati[NMAX];
int pacchettiDATAricevuti[NMAX];
int pacchettiDATAcollided[NMAX];

int pacchettiDATAmissedSync[NMAX];
int pacchettiDATALost[NMAX];
int pacchettiDATADropped[NMAX];
int pacchettiACKDATAinviati[NMAX];
int pacchettiACKDATAricevuti[NMAX];
int pacchettiACKDATAmissedSync[NMAX];

int pacchettiLEinviati[NMAX];
int pacchettiLEricevuti[NMAX];
int pacchettiLEmissedSync[NMAX];

int pacchettiLCinviati[NMAX];
int pacchettiLCricevuti[NMAX];
int pacchettiLCmissedSync[NMAX];

double delayrtt[NMAX][2];
double endTransmission[NMAX];
double transmittedPower[NMAX];
double RMS_Matrix[NMAX][NMAX];
double PEAK_Matrix[NMAX][NMAX];
double PEP[NMAX];
double BEP[NMAX];
double averagedelay[NMAX];

long StartTime, EndTime;
ofstream timeinfo;
long hopsdifference[NMAX][10];

int contafine;

int parametro;
FPL *packList;

void load_RMS(int run, int num_nodi)
{
	int i,j;
	char *RMS_file_name = (char *) malloc (20*sizeof(char));
	sprintf(RMS_file_name, "RUN%d_RMS.txt", run);
	FILE *RMS=fopen(RMS_file_name,"r");
	for (i=0;i<num_nodi;i++)
	{
		for (j=0;j<num_nodi-1;j++)	
		{	
			fscanf(RMS,"%lf ", &RMS_Matrix[i][j]);
			RMS_Matrix[i][j]=RMS_Matrix[i][j]*1E-9;
		}
		fscanf(RMS,"%lf\n", &RMS_Matrix[i][num_nodi-1]);
		RMS_Matrix[i][num_nodi-1]=RMS_Matrix[i][num_nodi-1]*1E-9;
	}
	fclose(RMS);
	free(RMS_file_name);
}
void load_PEAK(int run, int num_nodi)
{
	int i,j;
	char *PEAK_file_name = (char *) malloc (20*sizeof(char));
	sprintf(PEAK_file_name, "RUN%d_PEAK.txt", run);
	FILE *PEAK=fopen(PEAK_file_name,"r");
	for (i=0;i<num_nodi;i++)
	{
		for (j=0;j<num_nodi-1;j++)	
		{	
			fscanf(PEAK,"%lf ", &PEAK_Matrix[i][j]);
		}
		fscanf(PEAK,"%lf\n", &PEAK_Matrix[i][num_nodi-1]);
	}
	fclose(PEAK);
	free(PEAK_file_name);
}

void print_hopdifference(int numnodi,int esecuzione)
{
    ofstream fp;
    fp.open("hopdifference.vec",ios::app);
    fp<<"vector "<<esecuzione<<"  \"istogramma"<<esecuzione<<"\"  \"hopsdifference\"  1\n";
    
    long totsamples=0;
    for (int i=0;i<10;i++)
	for(int j=0;j<numnodi;j++)
	    totsamples+=hopsdifference[j][i];
	    
    for (int i=0;i<10;i++)
	{
	    long totsamplesi=0;
	    for (int j=0;j<numnodi;j++)
		{
		    totsamplesi+=hopsdifference[j][i];
		}
	    double pdfi=(double)totsamplesi/(double)totsamples;
	    fp<<esecuzione<<"  "<<i<<"  "<<pdfi<<endl;
	}
    fp.close();
}


void print_totali(int numnodi,int parametro,double mdeltot,double sdeltot)
{
    ofstream fp1;
    fp1.open("global.sca",ios::app);
    int richieste=0;
    int attivate=0;
    int rifiutate=0;
    /*
    for (int i=0;i<numnodi;i++)
    {
    richieste+=connessionirichieste[i];
    attivate+=connessioniattivate[i];
    rifiutate+=connessionirifiutate[i];
    }
    
    fp1<<"TOTALE: connessioni richieste: " << richieste << endl;
    fp1<<"  rifiutate: " << rifiutate << endl;
    */
    fp1<<"valore medio delayrtt: ";
    fp1<<mdeltot<<" deviazione standard delayrtt: ";
    fp1<<sdeltot<<endl;
    fp1.close();
}

void print_coordinates(int num_nodi, bool first,  double rangetx, int tent_max, double area_dim, int v_max, bool mobility,double time)
{
    int i;
    ofstream graph;
    graph.open("Graphics.dat",ios::app);
    if(first){
	
	graph<<"Algorithm:LAR1"<<endl;
	graph<<"Radio_range:"<<rangetx<<endl;
	graph<<"Number_of_tries:"<<tent_max<<endl;
	graph<<"Disposition:Random"<<endl;
	//graph<<"Max_NCF:-"<<endl;
	graph<<"Nodes:"<<num_nodi<<endl;
	graph<<"Area_dim:"<<area_dim<<"mx"<<area_dim<<"m"<<endl;
	//graph<<"Area_dim:"<<area_dim<<endl;
	graph<<"Max_speed:"<<v_max<<"m/s"<<endl;
	graph<<"Mobility:";
	if(mobility)
	    graph<<"yes"<<endl;
	else
	    graph<<"no"<<endl;
	
	graph<<num_nodi<<endl;
	graph<<area_dim<<endl;
	graph<<rangetx<<endl;
    }
    graph << "3" <<endl;
    graph << time <<endl;	
    for(i=0;i<num_nodi;i++)
    {
	graph<<database[i].x<<" "<<database[i].y<<endl;
    }
    graph.close();
}


void print_coordinates_powermap(int num_nodi, bool first, double rangetx, int tent_max, double area_dim, int v_max, bool mobility, double time, int max_index, double max_power, bool mincost)
{
    int i;
    ofstream powermapfile;
    powermapfile.open("PowerMap.dat",ios::app);
    if(first){
	
	powermapfile<<"Algorithm:LAR1"<<endl;
	powermapfile<<"Radio_range:"<<rangetx<<endl;
	powermapfile<<"Disposition:Random"<<endl;
	//graph<<"Max_NCF:-"<<endl;
	powermapfile<<"Nodes:"<<num_nodi<<endl;
	powermapfile<<"Area_dim:"<<area_dim<<"mx"<<area_dim<<"m"<<endl;
	//graph<<"Area_dim:"<<area_dim<<endl;
	powermapfile<<"Max_speed:"<<v_max<<"m/s"<<endl;
	powermapfile<<"Mobility:";
	if(mobility)
	    powermapfile<<"yes"<<endl;
	else
	    powermapfile<<"no"<<endl;
	if(mincost)
	    powermapfile<<"Metric:MinimumCost"<<endl;
	else
	    powermapfile<<"Metric:MinimumHop"<<endl;
	/*double area_dim=0;
	for(i=0;i<num_nodi;i++)
	{
	    if(database[i].x>area_dim)
		area_dim=database[i].x;
	    else
		if(database[i].y>area_dim)
		    area_dim=database[i].y;
	}
	*/
	
	powermapfile<<num_nodi<<endl;
	powermapfile<<area_dim<<endl;
	powermapfile<<rangetx<<endl;
	powermapfile<<max_index<<endl;
	powermapfile<<Resolution<<endl;
	powermapfile<<Integration_time<<endl;
	powermapfile<<max_power<<endl;
    }
    powermapfile << "3" <<endl; //Inserted for compatibility with DGT...
    powermapfile << time <<endl;	
    for(i=0;i<num_nodi;i++)
    {
	powermapfile<<database[i].x<<" "<<database[i].y<<endl;
    }
    powermapfile.close();
}
class Connectivity:public cSimpleModule

{
  Module_Class_Members (Connectivity, cSimpleModule, 8192*200) 
      
  int numnodi;
  int TOsim;
  int esecuzione;
  double mobilityinterval;
  double Ts;
  int Ns;
  double rangetx;

  int tent_max;
  int vmax;
  bool lar;
  double area_dim;
  bool mobilita;
  bool costFunctionModel;
  double erroremean;
    
  bool endsim;
  bool simterminate;
  
  int mobilityupdate;
  double max_power;
  int max_index;
  bool MinimumCost;
  int PACKETRATE;
  bool DEBUG; 
  cOutVector DATAinviatitot;
  cOutVector DATAricevutitot;
  cOutVector DATAcollidedtot;
  cOutVector DATAmissedSynctot;
  cOutVector DATALosttot;
  cOutVector DATADroppedtot;

  cOutVector ACKDATAinviatitot;
  cOutVector ACKDATAricevutitot;
  cOutVector ACKDATAmissedSynctot;

  cOutVector LEinviatitot;
  cOutVector LEricevutitot;
  cOutVector LEmissedSynctot;

  cOutVector LCinviatitot;
  cOutVector LCricevutitot;
  cOutVector LCmissedSynctot;
  cOutVector DATAThroughput;
  cOutVector meandelay;
  cOutVector stddevdelay;
  cOutVector AveragePEPtot;
  cOutVector AverageBEPtot;
  cOutVector Delay;  
  cStdDev totmeandelay;
  cStdDev totstddevdelay;
 //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
/*    
    void AggiornaErrore()
    {
    for (int i=0;i<numnodi;i++)
    {
    double errxi=genk_uniform(1,-erroremean,+erroremean);
    double erryi=genk_uniform(1,-erroremean,+erroremean);
    errorex[i]=errxi;
    errorey[i]=erryi;
    }
    }
*/
    void AggiornaMatriceConnessione ()	//procedura aggiorna matrice connessione rete sulla base vettore posizioni nodi
	{
	//breakpoint("sono in aggiornamatriceconnessione");
	for (int i = 0; i < numnodi; i++)
    	    {
		for (int j = i; j < numnodi; j++)
		    {
			if (i != j)
			    {
	    			double distij=sqrt(pow((database[i].x - database[j].x),2) + pow((database[i].y - database[j].y),2));
				if  (distij<rangetx)
				    {
					networkconnectivity[i][j]=true;
					networkconnectivity[j][i]=true;
					ev<<i<<"->";
					ev<<j<<" a ";
					ev<<"distanza "<<distij<<" minore rangetx " << rangetx << endl;
				    }
				
				else 
				    {
					networkconnectivity[i][j]=false;
					networkconnectivity[j][i]=false;
					ev<<i<<"->";
					ev<<j<<" a ";
					ev<<"distanza "<<distij<<" maggiore rangetx " << rangetx << endl;
				    }
			    }
		    }
	    }
	ev<<"matrice risultante\n";
	for (int i=0;i<numnodi;i++)
	    {
		for(int j=0;j<numnodi;j++)
		    {
			ev<<networkconnectivity[i][j]<<"-";
		    }
		ev<<"\n";
	    }
	ev<<"aggiornamatriceconnessione eseguito;\n";
	//breakpoint("aggiornamatriceconnessione eseguito");
	}	

    void AnnullaConnessioni ()	//procedura annulla tutte le connessioni rete
	{
	    for (int i = 0; i < numnodi; i++)
    		{
		    cModule *submodi=parentModule()->submodule("node",i);	    
		    for (int j=0; j<numnodi; j++)
			{
			    if (i!=j)
				{
				    
				    cModule *submodj=parentModule()->submodule("node",j);
				    submodi->gate("out", j)->setTo(NULL);
				    submodj->gate("in",i)->setFrom(NULL);
				}
			}
		    
		}
	    
	    ev<<"annullaconnessioni eseguito;\n";
	}

    
    
    void AggiornaConnessioni ()	//procedura connetti dinamicamente rete in base matrice connessione rete
    {
      //void function();
	//void * p=function;
	//	cPar* (*ritTX)()=RitardoTX;
	//cPar* (*errTX)()=ErroreTX;
	//cPar* (*ratTX)()=RateTX;
	
	//	cLinkType LinkFisico=cLinkType("LinkFisico",ritTX,errTX,ratTX);
	
	for (int i = 0; i < numnodi; i++)
    	    {
		
		
		cModule *submodi=parentModule()->submodule("node",i);
		
		
		for (int j = i; j < numnodi; j++)
		    {
			cModule *submodj=parentModule()->submodule("node",j);
			    
			if (networkconnectivity[i][j])
			    {
			      submodi->gate("out",j)->connectTo(submodj->gate("in",i));
			      submodj->gate("out",i)->connectTo(submodi->gate("in",j));
			      //connect (submodi,submodi->findGate ("out", j),(cLinkType*) &LinkFisico,submodj,submodj->findGate ("in",i));
			      //connect (submodj,submodj->findGate ("out", i),(cLinkType*) &LinkFisico,submodi,submodi->findGate ("in",j));
			    }
			
		    }
		
	    }
	ev<<"aggiornaconnessioni eseguito;\n";
    }	
  
 
 
    void AggiornaDisplayNodi()
    {
	for (int i=0;i<numnodi;i++)
    	    {
		    
		cModule *submodi=parentModule()->submodule("node",i);
		bool connesso=false;
		for (int j=0;j<numnodi;j++)
		    connesso=connesso||networkconnectivity[i][j];
		if(connesso)
		    submodi->setDisplayString("p=,,exact,$px,$py;i=ball_vs");
		else
		    submodi->setDisplayString("p=,,exact,$px,$py;i=ball_vs");
		
		ev<<"aggiornadisplaynodi"<<submodi->fullName()<<" eseguito;\n";
	    } 
    }	
    void AggiornaDisplayConnessioni()		
    {
    	for (int i=0;i<numnodi;i++)
    	    {
		cModule *submodi=parentModule()->submodule("node",i);
			
		for(int j=i;j<numnodi;j++)
		    {
			if(i!=j)
			    {
				cModule *submodj=parentModule()->submodule("node",j);
			    
				cGate *outgateij=submodi->gate("out",j);
				cGate *outgateji=submodj->gate("out",i);
		    
				outgateij->setDisplayString("o=blue,1",true);
			
				outgateji->setDisplayString("o=blue,1",true);
			    }
		    }
		ev<<"aggiornadisplayconnessioni"<<submodi->fullName()<<" eseguito;\n";
	    }
	
	
    }
  
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    


    virtual void initialize ();
    virtual void activity ();
    virtual void finish ();

};

Define_Module (Connectivity);


void Connectivity::initialize()
{
    StartTime=time(NULL);
    timeinfo.open("Timeinfo.txt",ios::app);
    timeinfo << "Initial Time is " << StartTime << endl;
    timeinfo.close();
    numnodi = parentModule ()->par ("numnodi");
    TOsim=parentModule()->par("TOsim");
    esecuzione=parentModule()->par("esecuzione");
    vmax=parentModule()->par("vmax");
    mobilityinterval = parentModule ()->par ("mobilityinterval");
    rangetx = parentModule ()->par ("rangetx");
    mobilita = parentModule ()->par ("mobilita");
    tent_max=parentModule ()->par ("numtentativi");
    //parametro=parentModule()->par("parametro");
    parametro =1; //hack...
    lar=parentModule ()->par ("lar");
    area_dim=parentModule ()->par ("area_dim");
    erroremean=parentModule()->par("erroremean");
    //costFunctionModel=parentModule()->par("costFunction");
    //PACKETRATE = parentModule ()->par ("PacketRate");
    Ts = parentModule ()->par ("Ts");
    Ns = parentModule ()->par ("Ns");
    PACKETRATE = 1/(Ts*Ns);
    DEBUG = parentModule() -> par("debug");
	int simulation_run = parentModule() -> par("esecuzione");
    ofstream intLE,intLC,intDATA;
    if(DEBUG)
      {
	intLE.open("Interf_LE.txt", ios::app);
	intLE << "#" << endl << "#" << endl;
	intLE << "# Terminals: " << numnodi << endl;
	intLE << "# Strategy: " << (costFunctionModel ? "Cost" : "Hops") << endl;
	intLE << "# Radio range: " << rangetx << endl;
	intLE << "# Area size: " << area_dim << endl;
	intLE << "# Mobility: " << mobilita << endl;
	intLE << "# PacketRate: "<< PACKETRATE << endl;
	intLE.close();
	
	intLC.open("Interf_LC.txt", ios::app);
	intLC << "#" << endl << "#" << endl;
	intLC << "# Terminals: " << numnodi << endl;
	intLC << "# Strategy: " << (costFunctionModel ? "Cost" : "Hops") << endl;
	intLC << "# Radio range: " << rangetx << endl;
	intLC << "# Area size: " << area_dim << endl;
	intLC << "# Mobility: " << mobilita << endl;
	intLC << "# PacketRate: "<< PACKETRATE << endl;
	intLC.close();
	
	intDATA.open("Interf_DATA.txt", ios::app);
	intDATA << "#" << endl << "#" << endl;
	intDATA << "# Terminals: " << numnodi << endl;
	intDATA << "# Strategy: " << (costFunctionModel ? "Cost" : "Hops") << endl;
	intDATA << "# Radio range: " << rangetx << endl;
	intDATA << "# Area size: " << area_dim << endl;
	intDATA << "# Mobility: " << mobilita << endl;
	intDATA << "# PacketRate: "<< PACKETRATE << endl;
	intDATA.close();
      }

    //MinimumCost = parentModule()->par("costFunction");
    packList= new FPL;
    max_power=STDPOWER;
    max_index = (int) area_dim/Resolution;

    PRESERVINGINTERVAL=(area_dim * sqrt(2)) / LIGHTSPEED + 2 * ((double) MAXDATASIZE/PACKETRATE);

    for (int i=0; i<NMAX; i++)
      {
	endTransmission[i]=0;
	transmittedPower[i]=0;
      }
    for (int i=0; i<numnodi; i++)	 
	for (int j = 0; j < numnodi; j++)
	  {
    	    networkconnectivity[i][j] = false;
	    generatedMUI[i][j] = 0;
	    NeighbourMatrix[i][j].distance = -1;
	    NeighbourMatrix[i][j].distanceValidity = false;
	    NeighbourMatrix[i][j].time = 0;
	    NeighbourMatrix[i][j].distanceEstimationTime = -1;
	    NeighbourMatrix[i][j].lastPacketTime = 0;
	    NeighbourMatrix[i][j].receivedPacketsMemory = 0;
	  }
    
    mobilityupdate=0;
    endsim=false;
    simterminate=false;
    contafine=0;
    
    ev<<"mobilityupdate "<<mobilityupdate<<" connectivity:\n";

	load_RMS(simulation_run, numnodi);
	load_PEAK(simulation_run, numnodi);
	//test
	ev << "RMS_matrix:\n";
	for (int i_test=0;i_test<numnodi;i_test++)
	{
		for (int j_test=0;j_test<numnodi-1;j_test++)	
		{	
			ev << RMS_Matrix[i_test][j_test] << " ";
		}
		ev << RMS_Matrix[i_test][numnodi-1] << "\n";
	}
	
	ev << "PEAK_matrix:\n";
	for (int i_test=0;i_test<numnodi;i_test++)
	{
		for (int j_test=0;j_test<numnodi-1;j_test++)	
		{	
			ev << PEAK_Matrix[i_test][j_test] << " ";
		}
		ev << PEAK_Matrix[i_test][numnodi-1] << "\n";
	}
	//test
	
    AggiornaMatriceConnessione ();
    
    AggiornaConnessioni();
    
    AggiornaDisplayNodi();
    
    AggiornaDisplayConnessioni();
    
    //    AggiornaErrore();
    ev<<"mobilityupdate "<<mobilityupdate<<" eseguito;\n";
    //print_coordinates(numnodi,true,rangetx,tent_max,area_dim,vmax,mobilita,0);
    print_coordinates_powermap(numnodi,true,rangetx,tent_max,area_dim,vmax,mobilita,simTime(),max_index,max_power,MinimumCost);
    ofstream powermapfile;
    powermapfile.open("PowerMap.dat",ios::app);
    for(int i=0;i<max_index;i++)
    {
	for(int j=0;j<max_index;j++)
	{
	    powermapfile<<"0 ";
	}
	powermapfile<<endl;
    }
    powermapfile.close();
    mobilityupdate+=1;
    DATAinviatitot.setName("DATAinviati");
    DATAricevutitot.setName("DATAricevuti");    
    DATAmissedSynctot.setName("DATAmissedSync");    
    DATALosttot.setName("DATALost");    
    DATAcollidedtot.setName("DATAcollided");    
    DATADroppedtot.setName("DATADropped");    

    ACKDATAinviatitot.setName("ACKDATAinviati");
    ACKDATAricevutitot.setName("ACKDATAricevuti");    
    ACKDATAmissedSynctot.setName("ACKDATAmissedSync");    

    LEinviatitot.setName("LEinviati");
    LEricevutitot.setName("LEricevuti");    
    LEmissedSynctot.setName("LEmissedSync");    

    LCinviatitot.setName("LCinviati");
    LCricevutitot.setName("LCricevuti");    
    LCmissedSynctot.setName("LCmissedSync");    

    DATAThroughput.setName("DATAthroughput");
    meandelay.setName("meandelay");
    stddevdelay.setName("stddevdelay");
    totmeandelay.setName("totmeandelay");
    totstddevdelay.setName("totstddevdelay");

    AveragePEPtot.setName("PEP");    
    AverageBEPtot.setName("BEP");    
    Delay.setName("Delay");
    cMessage* aggsta=new cMessage;
    //aggsta->setOwner(this);
    aggsta->setKind(AGGIORNASTA);
    aggsta->setName("CONN-AGGIORNASTA");
    ev<<(aggsta->owner())->fullName()<<endl;
    scheduleAt(simTime()+deltasincro,aggsta);

    cMessage *refresh=new cMessage;
    //refresh->setOwner(this);
    refresh->setKind(REFRESHLIST);
    refresh->setName("CONN-REFRESHLIST");
    scheduleAt(simTime()+PRESERVINGINTERVAL,refresh);
    /*    
	  cMessage *powermapUpdate=new cMessage;
	  powermapUpdate->setOwner(this);
	  powermapUpdate->setKind(POWERMAP);
	  scheduleAt(simTime()+POWERMAPINTERVAL,powermapUpdate);
    */
    if (mobilita)
	{
    	    cMessage *mob = new cMessage;
	    //mob->setOwner(this);
    	    mob->setKind(GENERAMOBUPDATE);
    	    mob->setPriority(10);
	    ev<<(mob->owner())->fullName()<<endl;
	    scheduleAt (simTime() + mobilityinterval+ deltasincro, mob);
	    
	}
}


void Connectivity::activity ()
{

    double milestone=0;    
    double powerMap[max_index][max_index];
    bool TimeMS=false;
    while (!simterminate)
	{

    	    if((simTime()>200)&&(!TimeMS))
	    {
		EndTime=time(NULL);
		timeinfo.open("Timeinfo.txt",ios::app);
		timeinfo<<"Final Time is "<<EndTime<<endl;
		timeinfo<<"Simulation duration is " << EndTime-StartTime<<endl;
		timeinfo.close();
		TimeMS=true;
		//ev<<"Tempo="<<simTime()<<endl;
		//milestone+=50;
	    }
	    cMessage *msg = receive();
	    int kind=msg->kind();
	    switch (kind)
		{
		    case GENERAMOBUPDATE:
			{	
			    ev<<"mobilityupdate "<<mobilityupdate<<" connectivity:\n";
			    
			    AggiornaMatriceConnessione();
			    			    
			    AnnullaConnessioni();
			    
			    AggiornaConnessioni();
			    
			    AggiornaDisplayNodi();
			    
			    AggiornaDisplayConnessioni();

			    //AggiornaErrore();
			    
			    //print_coordinates(numnodi,false,rangetx,tent_max,area_dim,vmax,mobilita,simTime());
			    
			    ev<<"mobilityupdate "<<mobilityupdate<<" eseguito;\n";
			    mobilityupdate+=1;
			    
			    //snapshot();
			    
			    cMessage *mob1 = new cMessage;
			    mob1->setKind(GENERAMOBUPDATE);
			    mob1->setPriority(10);
			    //mob1->setOwner(this);
			    scheduleAt (simTime() + mobilityinterval,mob1);
				
			}
    		    break;
		    
		case AGGIORNASTA:
		  {
		    int DATAinviati=0;
		    int DATAricevuti=0;
		    int DATAmissedSync = 0;
		    int DATALost = 0;
		    int DATAcollided=0;
		    int DATADropped=0;

		    int ACKDATAinviati=0;
		    int ACKDATAricevuti=0;
		    int ACKDATAmissedSync = 0;

		    int LEinviati = 0;
		    int LEricevuti = 0;
		    int LEmissedSync = 0;

		    int LCinviati = 0;
		    int LCricevuti = 0;
		    int LCmissedSync = 0;

		    double AveragePEP = 0;
		    double AverageBEP = 0;
		    double delay=0;
		    for (int i=0;i<numnodi;i++)
		      {
			DATAinviati+=pacchettiDATAinviati[i];
			DATAricevuti+=pacchettiDATAricevuti[i];
			DATAmissedSync+=pacchettiDATAmissedSync[i];
			DATALost+=pacchettiDATALost[i];
			DATAcollided+=pacchettiDATAcollided[i];
			DATADropped+=pacchettiDATADropped[i];
			ACKDATAinviati+=pacchettiACKDATAinviati[i];
			ACKDATAricevuti+=pacchettiACKDATAricevuti[i];				   
			ACKDATAmissedSync+=pacchettiACKDATAmissedSync[i];
			
			LEinviati+=pacchettiLEinviati[i];
			LEricevuti+=pacchettiLEricevuti[i];
			LEmissedSync+=pacchettiLEmissedSync[i];

			LCinviati+=pacchettiLCinviati[i];
			LCricevuti+=pacchettiLCricevuti[i];
			LCmissedSync+=pacchettiLCmissedSync[i];
			AveragePEP += PEP[i];
			AverageBEP += BEP[i];
			delay+=averagedelay[i];
		      }
		    
		    DATAinviatitot.record(DATAinviati);
		    DATAricevutitot.record(DATAricevuti);
		    DATAcollidedtot.record(DATAcollided);
		    DATAmissedSynctot.record(DATAmissedSync);
		    DATALosttot.record(DATALost);
		    DATADroppedtot.record(DATADropped);

		    ACKDATAinviatitot.record(ACKDATAinviati);
		    ACKDATAricevutitot.record(ACKDATAricevuti);
		    ACKDATAmissedSynctot.record(ACKDATAmissedSync);

		    LEinviatitot.record(LEinviati);
		    LEricevutitot.record(LEricevuti);
		    LEmissedSynctot.record(LEmissedSync);

		    LCinviatitot.record(LCinviati);
		    LCricevutitot.record(LCricevuti);
		    LCmissedSynctot.record(LCmissedSync);
		    AveragePEPtot.record(AveragePEP/numnodi);
		    AverageBEPtot.record(AverageBEP/numnodi);
		    Delay.record(delay/numnodi);

		    double throughputDATA = (double) DATAricevuti /(double) DATAinviati;
		    DATAThroughput.record(throughputDATA);
		    double mdel=0;
		    double stddel=0;
		    
		    for(int i=0;i<numnodi;i++)
		      {
			mdel+=delayrtt[i][0];
			stddel+=delayrtt[i][1];
		      }
		    double mdeltot=mdel/numnodi;
		    double stddeltot=stddel/numnodi;
		    
		    meandelay.record(mdeltot);
		    stddevdelay.record(stddeltot);				
		    
		    totmeandelay.collect(mdeltot);
		    totstddevdelay.collect(stddeltot);
		    cMessage* aggsta1=new cMessage;
		    aggsta1->setKind(AGGIORNASTA);
		    aggsta1->setName("CONN-AGGIORNASTA");
		    //aggsta1->setOwner(this);
		    scheduleAt(simTime()+STATINTERVAL,aggsta1);
		    
		    
		  }
		  break;
				    
		case FINE:
			{
			    ev<<"ricevo msg fine\n";
			    
			    int gateincon0=findGate("inconnectivity",0);
			    int index=(int)msg->arrivalGateId()-gateincon0;
			    
			    ev<<"relativo al nodo "<<index<<endl;
			
			    ev<<"stato endsim "<<endsim<<endl;
			    
			    contafine+=1;
			    if (contafine==numnodi)
				endsim=true; 
			    
			    ev<<"aggiorna endsim "<<endsim<<endl;
			    
			    if (endsim)
				{
				    ev<<"connectivity ha finito\n";
				    double mdeltot=(double)totmeandelay.mean();
				    double sdeltot=(double)totstddevdelay.mean();
				    
				    print_totali(numnodi,parametro,mdeltot,sdeltot);
				    if(!mobilita)
					print_hopdifference(numnodi,esecuzione);
				    
				    cMessage *fine=new cMessage;
				    fine->setKind(FINE);
				    for (int i=0;i<numnodi;i++)
					{
					    cModule *nodei=parentModule()->submodule("node",i);
					    cGate *conin=nodei->gate("conin");
					    cMessage *copy=(cMessage*)fine->dup(); 
					    sendDirect(copy,10,conin);
					}
				    delete fine;
				    cMessage* closeall=new cMessage;
				    closeall->setKind(TERMINATE);
				    closeall->setName("CONN-TERMINATE");
				    //closeall->setOwner(this);
				    scheduleAt(simTime()+25,closeall);
				}
			    else
			    {
				ev<<"connectivity ancora non ha finito\n";
			    }        
			}
		    break;
		    case REFRESHLIST:
			{
			    packList->refreshList(simTime(), PRESERVINGINTERVAL);
			    cMessage *refresh=new cMessage;
			    refresh->setKind(REFRESHLIST);
			    refresh->setName("CONN-REFRESHLIST");
			    scheduleAt(simTime()+REFRESHINGINTERVAL,refresh);
			}
		    break;
		    
		    case TERMINATE:
			{
			    simterminate=true;
			}
		    break;
		}
	    delete msg;
	}
    
    //snapshot();
}


void Connectivity::finish()
{
    delete packList;
    ev<<"Finito Connectivity"<<endl;
    
    //snapshot(this);
}
