#ifndef _PacketDescriptor
#define _PacketDescriptor

/*  
    PacketDescriptor.h
    Each instance defines a packet transmitted in the network. 
    It is used to evaluate interference on each received packet
*/
    
class PacketDescriptor
{
    
    public:
    
    PacketDescriptor(int nodeID, int packetID, int destinationID, int connID, double txTime, int packetKind, double packetDuration, bool trypacket=false, double x=-1,double y=-1,double pTx=-1);
    int _nodeID;
    int _destinationID;
    int _packetID;
    int _connID;
    double _txTime;
    int _packetKind;
    double _packetDuration;
    double _x;			//The parameters _x, _y refer to transmitter position, _pTx is the power at the transmitter 
    double _y;			//_x, _y and _pTx are used to evaluate the effect of the packet on each reception
    double _pTx;
    bool _trypacket;		//Not used any more
    PacketDescriptor *next;
};
#endif
